package main

import (
	"fmt"
	"net"
	"io/ioutil"
//	"os"
)

var (
	banner []byte
)

func main() {
	ln, err := net.Listen("tcp", ":9727")
	if err != nil {
		panic(err)
	}
	fmt.Println("Listening on localhost:9727")
	
	fmt.Print("Initializing...")
	banner, _ = ioutil.ReadFile("./banner.txt")
	fmt.Println("DONE")
	
	for {
		conn, err := ln.Accept()
		if err != nil {
			fmt.Println(err)
			continue
		}
		
		go handleConnection(conn)
	}
}

func output(m string, c net.Conn) bool {
	_, err := c.Write([]byte(m))
	if err != nil {
		c.Close()
		return false
	}
	return true
}

func outputBytes(m []byte, c net.Conn) bool {
	_, err := c.Write(m)
	if err != nil {
		c.Close()
		return false
	}
	return true
}

const (
	colBlue = "\033[0;34m"
	colGreen = "\033[0;32m"
	colBGreen = "\033[1;32m"
	colCyan = "\033[0;36m"
	colBold = "\033[1;37m"
	noCol = "\033[0m"
)

func handleConnection(c net.Conn) {
	//b := make([]byte, 4096)
	
	outputBytes(banner, c)
	output(fmt.Sprintf("\n%sWelcome to write.as!%s\n", colBGreen, noCol), c)
	output(fmt.Sprintf("You're %swriting%s—you don't need that mouse. But if you'd rather not leave it\nbehind, sign up for the web-based launch at https://write.as.\n", colBold, noCol), c)
	
	output("\nThat's all (for now), folks!\n", c)
	c.Close()
	/*
	for {
		n, err := c.Read(b)
		if err != nil || n == 0 {
			c.Close()
			break
		}
		
		ok := outputBytes(b[0:n], c)
		if !ok {
			break
		}
	}
	*/
	fmt.Printf("Connection from %v closed.\n", c.RemoteAddr())
}
